Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## swarm.defobj
Interface CreateC

All Known Subinterfaces:
  ActionC, ActionCacheC, ActionCallC, ActionChangedC, ActionConcurrentC, ActionForEachC, ActionForEachHomogeneousC, ActionGroupC, ActionToC, ActivationOrderC, ActiveGraphC, ActiveOutFileC, ActivityControlC, ArchivedGeometryWidgetC, ArchiverC, ArgumentsC, ArrayC, AveragerC, BasicRandomGeneratorC, BehaviorPhaseC, BernoulliDistC, BinomialDistC, BooleanDistributionC, C2TAUS1genC, C2TAUS2genC, C2TAUS3genC, C2TAUSgenC, Ca2dC, CanvasAbstractItemC, CanvasC, CanvasItemC, CollectionC, ColormapC, CommonProbeDisplayC, CompleteProbeDisplayC, CompleteProbeMapC, CompleteVarMapC, CompositeItemC, CompoundActionC, ConcurrentGroupC, ConcurrentScheduleC, ControlPanelC, ConwayLife2dC, CreatedClassC, CustomProbeMapC, DblBuffer2dC, DefaultProbeMapC, Diffuse2dC, Discrete2dC, DoubleDistributionC, EmptyProbeMapC, EntropyC, ErrorC, EventTypeC, ExponentialDistC, EZAverageSequenceC, EZBinC, EZDistributionC, EZGraphC, EZSequenceC, FActionC, FActionForEachC, FActionForEachHeterogeneousC, FActionForEachHomogeneousC, FArgumentsC, FCallC, GammaDistC, GraphC, GraphElementC, Grid2dC, GUISwarmC, HDF5ArchiverC, HDF5C, HistogramC, Int2dFilerC, IntegerDistributionC, KeyedCollectionC, LinkItemC, LispArchiverC, ListC, ListShufflerC, LogNormalDistC, MapC, MessageProbeC, MT19937genC, MultiVarProbeDisplayC, NodeItemC, NormalC, NormalDistC, NSelectC, Object2dDisplayC, OvalNodeItemC, PermutationC, PermutationItemC, PixmapC, PMMLCG1genC, PMMLCGgenC, PoissonDistC, ProbabilityDistributionC, ProbeC, ProbeDisplayC, ProbeDisplayManagerC, ProbeLibraryC, ProbeMapC, PSWBgenC, QSortC, RandomBitDistC, RasterC, RectangleNodeItemC, ScheduleC, SimpleProbeDisplayC, SimpleRandomGeneratorC, SingleProbeDisplayC, SplitRandomGeneratorC, StringC, SwarmC, SwarmObjectC, SwarmProcessC, SymbolC, UNameC, UniformDoubleDistC, UniformIntegerDistC, UniformUnsignedDistC, UnsignedDistributionC, Value2dDisplayC, VarProbeC, WarningC, WidgetC, ZoneC, ZoomRasterC

All Known Implementing Classes:
  ArgumentsCImpl, FArgumentsCImpl, FCallCImpl, HDF5CImpl, SymbolCImpl, ZoneCImpl, PermutationCImpl, ListShufflerCImpl, StringCImpl, ProbeLibraryCImpl, SwarmObjectCImpl, GraphElementCImpl, PixmapCImpl, ColormapCImpl

public interface CreateC
extends DefinedObjectC, DefinedObjectS, CustomizeC, CustomizeS

Create an instance of a type with optional customization.. The Create supertype defines standard messages that provide a general-purpose protocol for creating new objects. These messages may be used either to create a new instance of a type in one message, or to bracket a series of messages that customize available options for an object to be created. The separation of create-time specifications from later behavior of an object gives substantial flexibility to adapt a generic type to particular needs. These create messages may be implemented either by a type that hides its implementing classes, or directly by a class that adopts these messages as a uniform interface for creating objects. If implemented directly by a class, then the class object serves as the type object in all message descriptions that follow. Otherwise, a type object might be implemented in a variety of ways that guarantee only that published messages on a type are accepted. In addition to the create messages defined by Create, an object type may support any other messages of any other names or calling conventions. These messages define only a standard method for creating new objects that other types are free to inherit and implement in conformance with a uniform convention. Further conventions are established elsewhere create combination messages for standard ways in which create messages that combine several steps can be combined. Any interim object returned by either createBegin: or customizeBegin: supports the getZone and drop messages that a finalized instance may also support. These messages are defined by the Drop type, which is normally inherited by a type to declare these messages on a finalized instance. This type is not inherited by the Create type because the messages would then apply to the finalized instance, not to the interim object. Even though not declared, the messages are available on the interim objects nonetheless. The drop message on an interim object may be used if it turns out that a finalized version is no longer required after creation or customization has already begun. The createBegin: and createEnd messages bracket a series of messages that specify options for an object being created. The intermediate messages can set values defined as parameters of the type, or provide other forms of specification using available messages. A particular object type defines the specific messages that are valid for sending during this interim creation phase.

Method Summary
`java.lang.Object` | `create(Zone aZone)` The create: message creates a new instance of a type with default options.
`java.lang.Object` | `createBegin(Zone aZone)` createBegin: returns an interim object intended only for receiving create-time messages.
`java.lang.Object` | `createEnd()` The createEnd message completes the process of specifying available options for an object being created.

Methods inherited from interface swarm.defobj.CustomizeC
`customizeBegin, customizeCopy, customizeEnd`

Method Detail

### create

    public java.lang.Object create(Zone aZone)

  The create: message creates a new instance of a type with default options. The zone argument specifies the source of storage for the new object. The receiving object of this message is a previously defined type object. The message is declared as a class message (with a + declaration tag) to indicate that the message is accepted only by the type object itself rather than an already created instance of the type (which a - declaration tag otherwise defines). The create: message returns the new object just created. This object is an instance of some class selected to implement the type. The class which a type selects to implement an object may be obtained by the getClass message, but is not otherwise visible to the calling program. A caller never refers to any class name when creating objects using these messages, only to type names, which are automatically published as global constants from any @protocol declaration.

### createBegin

    public java.lang.Object createBegin(Zone aZone)

  createBegin: returns an interim object intended only for receiving create-time messages. If a type was defined by a @protocol declaration, these messages are those appearing in either the CREATING or SETTING sections. Otherwise, the messages valid as create-time messages are defined by the type without any specific syntactic marker.

### createEnd

    public java.lang.Object createEnd()

  The createEnd message completes the process of specifying available options for an object being created. Typically it validates that requested options are valid and consistent with one another, and raises an error if they are not. The standard, predefined error InvalidCombination may be raised by createEnd to indicate an invalid combination of requests, or other, more specific forms of error handling may be used. If all requests received since the initial createBegin: are valid, both individually and in combination with each other, then createEnd determines a finalized form of object that satisfies all requests received and then returns this object. Any additional storage required for the finalized object is taken from the same zone originally passed to createBegin. The object may have whatever implementation is selected to best satisfy a particular request. Different requests may result in entirely different implementations being returned. The only guarantee is that a returned object supports the messages defined for further use of the finalized object. If a type was defined by a @protocol declaration, these messages are those appearing in either the SETTING or USING sections. On return from createEnd, the id of the interim object returned by createBegin: is no longer guaranteed to be valid for further use, and should no longer be referenced. A variable which holds this such an id can be reassigned the new id returned by createEnd, so that the same variable holds successive versions of the object being created.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD